# Software Development Process

[![Maintained][maintained-img]][maintained]
[![License][license-img]][license]
[![Accessibility][accessibility-img]][accessibility]

This repository was created for enterprise level software development processes. Its primary functions are:

1. Build easy to read, develop, and maintain code.
   1. MVC and MVVM styles
   2. Web based styles
   3. Cross platform styles
2. Create great documentation.
   1. Extensive GFM [Markdown](markdown) and Kramdown Languages.
   2. Word processing and PDF user documents.
   3. HTML and online user documents.
3. Properly use a repository
   1. [GitLab](https://www.gitlab.com)
   2. [GitHub](https://www.github.com)

## Building Easy to read and maintain code

Create a standards of code policy, by using ECMA Script, .NET, Ruby, Rails, and even HTML Standards that are currently in public use. Most high level schooling will use these standards in their studies, which will allow new employees to pick up and start work right away. Review the Coding Standards below to understand how these may be applied to the environment.

## Documentation

If your documentation is out of date, or hard to read, or even non-existent. Then not only does it make it extremely more difficult for other developers to assist you, but if many months, or even years have gone by, you will have to relearn your entire code.

This is where proper documentation assists with all of these issues. Below are great resources that I have put together to help software developers build great documents for others to jump right in and start assisting with your project.

## Quick Start

This is a read-only document project, no other software or specialized settings are required to navigate through these documents.

## Navigation

| [Home][home] | [Develop Cycle][dev-cycle] | [Document Scope][doc-scope] | [Software version][software-ver] | [Project reference][proj-ref] | [Source Control][source-ctrl] | [Code Reviews][code-review] | [Coding Standard][code-std] |
|:---:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| [![i1][home-img]][home] | [![i2][dev-cycle-img]][dev-cycle] | [![i3][doc-scope-img]][doc-scope] | [![i4][software-ver-img]][software-ver] | [![i5][proj-ref-img]][proj-ref] | [![i6][source-ctrl-img]][source-ctrl] | [![i7][code-review-img]][code-review] | [![i8][code-std-img]][code-std] |

## Contributing

We're committed to a loosely-coupled architecture and would love to get your contributions within each of the categories available.

If you would like help implementing a practice, how-to guide, or adding an additional enrichment, check out our **[Contributing](/Contrubiting.md)** document.

## Copyright and license

These documents have been created 2020.

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this software except in compliance with the License.

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

<!-- Identifiers -->
[home]: /README.md "The main context of this entire document"
[dev-cycle]: /documentation/Dev_Cycle.md "An overview of the development process cycle"
[doc-scope]: /documentation/Documentation_Scopes.md "A detailed tutorial on documentation scopes"
[software-ver]: /documentation/Software_Versioning.md "Logical concept on software versioning"
[proj-ref]: /documentation/Project_References.md
[source-ctrl]: /documentation/Source_Control.md
[code-review]: /documentation/Code_Reviews.md
[code-std]: /documentation/Coding_Standards.md
[markdown]: /documentation/Markdown_Language_Guide.md
[maintained]: https://img.shields.io/maintenance/yes/2019.svg
[license]: https://www.apache.org/licenses/LICENSE-2.0
[accessibility]: https://img.shields.io/wheelmap/a/26699541.svg

<!-- Images -->
[home-img]: /documentation/images/home.png
[dev-cycle-img]: /documentation/images/development_cycle.png
[doc-scope-img]: /documentation/images/documentation_scope.png
[software-ver-img]: /documentation/images/software_versioning.png
[proj-ref-img]: /documentation/images/project_references.png
[source-ctrl-img]: /documentation/images/source_control.png
[code-review-img]: /documentation/images/code_review.png
[code-std-img]: /documentation/images/code_standards.png
[maintained-img]: https://img.shields.io/maintenance/yes/2019.svg
[license-img]: https://img.shields.io/badge/license-Apache--2-blue.svg?style=flat
[accessibility-img]: https://img.shields.io/wheelmap/a/26699541.svg